SystemOrganization addCategory: #'Glamour-Seaside'!

WAComponent subclass: #SGLExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside'!

!SGLExamples methodsFor: 'examples' stamp: 'lr 2/25/2009 16:56'!
classNavigator
	" self new classNavigator openOn: (BrowserEnvironment new forPackageNamed: 'Glamour') "

	| browser |
	browser := GLMTableLayoutBrowser new.
	browser 
		column: #classes; column: #selectors;
		row: #source span: 2.

	" classes "
	browser showOn: #classes; using: [
		browser list
			display: [ :environment | environment allClasses ];
			format: [ :each | each name ] ].

	" classes " 
	browser showOn: #selectors; from: #classes; using: [
		browser list
			display: [ :class | class selectors ];
			format: [ :each | each asString ] ].
		
	" source "
	browser showOn: #source; from: #classes; from: #selectors; using: [
		browser text
			"when: [ :class :selector | selector isNil ];"
			display: [ :class :selector | class definition ].
		browser text
			when: [ :class :selector | selector notNil ];
			display: [ :class :selector | class sourceCodeAt: selector ] ].

	^ browser! !

WAComponent subclass: #SGLWindow
	instanceVariableNames: 'pane html uuid scripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside'!

!SGLWindow classSide methodsFor: 'rendering' stamp: 'lr 2/25/2009 14:19'!
on: aUI
	^ self new pane: aUI! !

!SGLWindow methodsFor: 'private' stamp: 'lr 2/25/2009 15:18'!
description
	^ 'Glamour'! !

!SGLWindow methodsFor: 'private' stamp: 'lr 2/25/2009 14:20'!
new
	^ self! !

!SGLWindow methodsFor: 'accessing' stamp: 'lr 2/25/2009 14:19'!
pane: aPane
	pane := aPane! !

!SGLWindow methodsFor: 'rendering' stamp: 'lr 2/25/2009 16:18'!
renderContentOn: aRenderer
	html := aRenderer.
	uuid := IdentityDictionary new.
	scripts := OrderedCollection new.
	pane renderGlamorouslyOn: self! !

!SGLWindow methodsFor: 'rendering-presentation' stamp: 'lr 2/25/2009 16:15'!
renderListPresentation: aPresentation
	| items toShow |
	toShow := aPresentation displayValue.
	items := toShow isCollection
		ifTrue: [ toShow ]
		ifFalse: [ Array with: toShow ].
	items := items ifNil: [ OrderedCollection new ].
	html select
		size: 10;
		list: items;
		labels: aPresentation format;
		selected: aPresentation selection;
		id: (self uuidFor: aPresentation);
		callback: [ :value | aPresentation selection: value ];
		onChange: (html jQuery ajax 
			serializeThis;
			script: [ :script | self updateScript: script ])! !

!SGLWindow methodsFor: 'rendering-presentation' stamp: 'lr 2/25/2009 15:20'!
renderMondrianPresentation: aMondrianPresentation
	html text: 'mondrian'! !

!SGLWindow methodsFor: 'rendering-widgets' stamp: 'lr 2/25/2009 16:54'!
renderPane: aPane
	| id |
	html div
		id: (id := self uuidFor: aPane);
		with: [
			aPane matchingPresentations
				do: [ :each | each renderGlamorouslyOn: self ] ].
	aPane whenMatchingPresentationsChanged: [ :ann |
		scripts add: ((html jQuery id: id) html: [ :r | 
			html := r.
			aPane matchingPresentations
				do: [ :each | each renderGlamorouslyOn: self ] ]) ]! !

!SGLWindow methodsFor: 'rendering-widgets' stamp: 'lr 2/25/2009 16:48'!
renderTableLayoutBrowser: aBrowser
	html table class: (self uuidFor: aBrowser); with: [ 
		aBrowser cell isRow
			ifTrue: [ self renderTableLayoutBrowserRow: aBrowser ]
			ifFalse: [ self renderTableLayoutBrowserColumn: aBrowser ] ]! !

!SGLWindow methodsFor: 'rendering-widgets' stamp: 'lr 2/25/2009 16:50'!
renderTableLayoutBrowserColumn: aBrowser
	| element |
	aBrowser cell children do: [ :each |
		html tableRow: [
			html tableData rowSpan: each span; with: [
				each hasId ifTrue: [ 
					element := aBrowser paneNamed: each id.
					element renderGlamorouslyOn: self ] ] ] ]! !

!SGLWindow methodsFor: 'rendering-widgets' stamp: 'lr 2/25/2009 16:49'!
renderTableLayoutBrowserRow: aBrowser
	| element |
	html tableRow: [
		aBrowser cell children do: [ :each |
			html tableData colSpan: each span; with: [
				each hasId ifTrue: [ 
					element := aBrowser paneNamed: each id.
					element renderGlamorouslyOn: self ] ] ] ]! !

!SGLWindow methodsFor: 'rendering-presentation' stamp: 'lr 2/25/2009 16:29'!
renderTextPresentation: aPresentation
	| toShow |
	toShow := aPresentation formatedDisplayValue.
	html textArea
		value: toShow;
		id: (self uuidFor: aPresentation);
		callback: [ :value | aPresentation text: value ];
		onChange: (html jQuery ajax 
			serializeThis;
			script: [ :script | self updateScript: script ])! !

!SGLWindow methodsFor: 'rendering-presentation' stamp: 'lr 2/25/2009 15:20'!
renderTreePresentation: aTreePresentation
	html text: 'tree'! !

!SGLWindow methodsFor: 'rendering-presentation' stamp: 'lr 2/25/2009 15:20'!
renderWorkspacePresentation: aWorkspacePresentation
	html text: 'workspace'! !

!SGLWindow methodsFor: 'rendering' stamp: 'lr 2/25/2009 16:34'!
style
	^ 'div { border: 1px red solid; }
	td { border: 1px blue solid; }
	
	
div { width: 100%; }
select { width: 100%; height: 200px; }
textarea { width: 100%; height: 200px; }
'! !

!SGLWindow methodsFor: 'rendering' stamp: 'lr 2/25/2009 14:20'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot title: 'Seaside Glamour'! !

!SGLWindow methodsFor: 'private' stamp: 'lr 2/25/2009 16:19'!
updateScript: aScript
	aScript addAll: scripts.
	scripts := OrderedCollection new! !

!SGLWindow methodsFor: 'private' stamp: 'lr 2/25/2009 15:11'!
uuidFor: anObject
	| key |
	^ uuid at: anObject ifAbsentPut: [
		[ key := WAExternalID new.
		  uuid includesKey: key ] 
			whileTrue.
	 	key ]! !

!Symbol methodsFor: '*glamour-seaside' stamp: 'lr 2/25/2009 16:10'!
fixCallbackTemps! !

GLMRenderer subclass: #SGLRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside'!

!SGLRenderer methodsFor: 'rendering' stamp: 'lr 2/25/2009 15:47'!
open: aRenderable
	| application |
	application := WAAdmin 
		register: (SGLWindow on: aRenderable)
		asApplicationAt: 'glamour'.
	application configuration
		addParent: WADevelopmentConfiguration instance.
	application addLibrary: JQDeploymentLibrary! !
